/*
 * Created on 19-06-2003
 */
package algoritmer;

import gui.*;

/**
 * @author SnakeByte
 *
 * The contents of this file may be used for 
 * private or educational use only.
 * Denne klasse er en serviceklasse til brug i GUI- eksemplet
 */
public class AlgorithmExtension {

private MyJPanel parent;//The sort item.
private boolean stopsort = false;//  nr den er sat til true stoppes sortering

	/**
	 * 
	 */
	public AlgorithmExtension() {
		super();
	}
	
	/**
	 * Set the parent.
	 */
	public void setParent( MyJPanel p ) {
		parent = p;
	}
	
	/**
	 * Pause for a while.
	 */
	public void pause() throws Exception {
		if( stopsort ) {
			throw new Exception("Sort Algorithm");
		}
		parent.pause( parent.getH1(), parent.getH2() );
	}
	
	/**
	 * Pause for a while and mark item 1.
	 */
	public void pause( int H1 ) throws Exception {
		if( stopsort ) {
			throw new Exception("Sort Algorithm");
		}
		parent.pause( H1, parent.getH2() );
	}

	/**
	 * Pause for a while and mark item 1 & 2.
	 */
	public void pause(int H1, int H2) throws Exception {
		if( stopsort ) {
			throw new Exception("Sort Algorithm");
		}
		parent.pause( H1, H2 );
	}
	
	public void stopSort() {
		stopsort = true;
	}
	
	public void init() {
		stopsort = false;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean getStopsort() {
		return stopsort;
	}
	
	/**
	 *	
	 * @param b
	 */
	public void setStopsort( boolean b ) {
		stopsort = b;
	}
}
