/*
 * Created on 07-07-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package algoritmer;

import java.util.*;

/**
 * @author Knud Albrechtsen (SnakeByte)
 */
public class MyBidirectionalBubbleSort extends AlgorithmExtension implements SortAlgorithm {

private int[] arr;
private Vector vector;

	/**
	 * 
	 */
	public MyBidirectionalBubbleSort() {
		super();
	}

	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		int marker;
		int length = a.length;
		int st = -1;
		while( st < length ) {// slnge length > -1
			boolean flipped = false;
			st++;//st tlles en op
			length--;//length tlles en ned
			for( marker = st; marker < length; marker++ ) {
				//marker sttes til st og tlles op til length
				if( getStopsort() ) {
					return;
				}
				if( a[marker] > a[marker + 1] ) {
					int tmp = a[marker];
					a[marker] = a[marker + 1];
					a[marker + 1] = tmp;
					flipped = true;
					pause( st, length );
				}
			}
			if( !flipped ) {
				//hvis der ikke er byttet p nogle elementer
				return;
			}
			for( marker = length; --marker >= st; ) {
				//marker sttes til length og tlles ned til st
				if( getStopsort() ) {
					return;
				}
				if( a[marker] > a[marker + 1] ) {
					int tmp = a[marker];
					a[marker] = a[marker + 1];
					a[marker + 1] = tmp;
					flipped = true;
					pause( st, length );
				}
			}
			if( !flipped ) {
				return;
			}
		}
		arr = a;
		pause( st, length );
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med BidirectionalBubbleSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med BidirectionalBubbleSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}

}
