/*
 * Created on 24-06-2003
 */
package algoritmer;

import java.util.*;

/**
 * @author SnakeByte
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
public class MyInsertionSort extends AlgorithmExtension implements SortAlgorithm {

private  int[] arr;
private Vector vector;

	/**
	 * 
	 */
	public MyInsertionSort() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		arr = a;
		int tmp;
		int marker1 = 1;
		int marker2 = 0;
		while( marker1 < arr.length ) {
			if( arr[marker1] < arr[marker1 - 1] ) {
				tmp = arr[marker1];
				marker2 = marker1;
				while( ( marker2 > 0 ) && ( arr[marker2-1] > tmp ) ) {
					if( getStopsort() ) {
						return;
					}
					arr[marker2] = arr[marker2-1];
					marker2--;
					pause( marker1, marker2 );
				}
				arr[marker2] = tmp;
			}
			marker1++;
			pause( marker1, marker2 );
		}
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med InsertionSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med InsertionSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}
}
