/*
 * Created on 18-06-2003
 *
 * This contents of this file may be used for
 *  private or educational use only.
 */
package algoritmer;

import java.util.*;

/**
 * @author SnakeByte
 */
public class MyMergeSort extends AlgorithmExtension implements SortAlgorithm {

private int[] arr;
private Vector vector;

	/**
	 * 
	 * 
	 */
	public MyMergeSort() {
		super();
	}
	
	/*-------------------------Sortering af Arrays------------------------------------*/
	public void sort( int a[] ) throws Exception {
		sort( a, 0, a.length - 1 );
	}
	
	public void sort( int a[], int lo, int hi ) throws Exception {
		int low = lo;
		int high = hi;
		pause( low, high );
		if( low >= high ) {
			return;
		}
		int mid = ( low + high ) / 2;
		//arrayet deles op i to og sorteres rekursivt
		sort( a, low, mid );
		sort( a, mid + 1, high );
		//de to sorterede lister samles
		int end_lo = mid;
		int start_hi = mid + 1;
		while( ( low <= end_lo ) && ( start_hi <= high ) ) {
			pause( low );
			if( getStopsort() ) {
				return;
			}
			if( a[low] < a[start_hi] ) {
				low++;
			}
			else {
				int tmp = a[start_hi];
				for( int k = start_hi - 1; k >= low; k-- ) {
					a[k+1] = a[k];
				}
				a[low] = tmp;
				low++;
				end_lo++;
				start_hi++;
			}
		}
		arr = a;
	}
	/*-------------------------Slut p sortering af arrays----------------------------*/
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return null;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med MergeSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med MergeSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}
	
}
